#include "NRF24L01.h"
#include "NRF_USER.h"

volatile _dev_nrf_ NRF_Device;
volatile _nrf_data_ NRF_Data = {
    { 0 },//TX_Data
    {
        { 0 },//RX_Data[0]
        { 0 },//RX_Data[1]
        { 0 },//RX_Data[2]
        { 0 },//RX_Data[3]
        { 0 },//RX_Data[4]
        { 0 },//RX_Data[5]
    },
};

void NRF_Config(void);

void Init_NRF()
{
    GPIO_InitTypeDef GPIO_InitStructure;

    /*
    豸ṹʼ
    */
    USER_Config_NRF_Device();

    /*
    ָʼ
    */
    NRF_Device.Init_RCC = USER_Init_RCC;
    NRF_Device.Init_SPI = USER_Init_SPI;
    NRF_Device.Init_TIM = USER_Init_TIM;
    NRF_Device.Init_IRQ = USER_Init_IRQ;
    NRF_Device.TIM_IRQ = USER_NRF_TIM_IRQ;
    NRF_Device.NRF_IRQ = USER_NRF_IRQ;

    /*
    ʱӳʼ
    */
    NRF_Device.Init_RCC();

    /*
    IOųʼ
    */
    GPIO_InitStructure.GPIO_Pin = 1 << NRF_Device.CE_Pin.GPIO_Pin;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
    GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
    GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_Init(NRF_Device.CE_Pin.GPIO_Port, &GPIO_InitStructure);

    GPIO_InitStructure.GPIO_Pin = 1 << NRF_Device.CS_Pin.GPIO_Pin;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
    GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
    GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_Init(NRF_Device.CS_Pin.GPIO_Port, &GPIO_InitStructure);

    /*
    SPIųʼ
    */
    GPIO_InitStructure.GPIO_Pin = 1 << NRF_Device.MISO_Pin.GPIO_Pin;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;
    GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
    GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_Init(NRF_Device.MISO_Pin.GPIO_Port, &GPIO_InitStructure);
    GPIO_PinAFConfig(NRF_Device.MISO_Pin.GPIO_Port,
        NRF_Device.MISO_Pin.GPIO_Pin,
        NRF_Device.CLK_Pin.GPIO_AF);

    GPIO_InitStructure.GPIO_Pin = 1 << NRF_Device.MOSI_Pin.GPIO_Pin;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;
    GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
    GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_Init(NRF_Device.MOSI_Pin.GPIO_Port, &GPIO_InitStructure);
    GPIO_PinAFConfig(NRF_Device.MOSI_Pin.GPIO_Port,
        NRF_Device.MOSI_Pin.GPIO_Pin,
        NRF_Device.MISO_Pin.GPIO_AF);
        
    GPIO_InitStructure.GPIO_Pin = 1 << NRF_Device.CLK_Pin.GPIO_Pin;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF;
    GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
    GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_Init(NRF_Device.CLK_Pin.GPIO_Port, &GPIO_InitStructure);
    GPIO_PinAFConfig(NRF_Device.CLK_Pin.GPIO_Port,
        NRF_Device.CLK_Pin.GPIO_Pin,
        NRF_Device.MOSI_Pin.GPIO_AF);

    /*
    IRQųʼ
    */
    GPIO_InitStructure.GPIO_Pin = 1 << NRF_Device.IRQ_Pin.GPIO_Pin;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN;
    GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_Init(NRF_Device.IRQ_Pin.GPIO_Port, &GPIO_InitStructure);

    /*
    IOλεַʼ
    */
    NRF_Device.CE = GET_BITBAND_WRITE_POINTER(NRF_Device.CE_Pin.GPIO_Port,
        NRF_Device.CE_Pin.GPIO_Pin);
    NRF_Device.CS = GET_BITBAND_WRITE_POINTER(NRF_Device.CS_Pin.GPIO_Port,
        NRF_Device.CS_Pin.GPIO_Pin);
	NRF_Device.IRQ = GET_BITBAND_READ_POINTER(NRF_Device.IRQ_Pin.GPIO_Port,
		NRF_Device.IRQ_Pin.GPIO_Pin);

    *NRF_Device.CE = 0;
    *NRF_Device.CS = 1;

    /*
    SPIʼ
    */
    NRF_Device.Init_SPI();

    /*
    ʱʼ
    */
    NRF_Device.Init_TIM();

    /*
    жϳʼ(ʱжNRFж)
    */
    NRF_Device.Init_IRQ();
    
    delay_ms(1);
    
    /*
    NRF24L01
    */
    NRF_Config();
}

u8 NRF_SPI_Data(u8 dat)
{
    while ((NRF_Device.SPI->SR & (1 << 1)) == 0);
    NRF_Device.SPI->DR = dat;
    while ((NRF_Device.SPI->SR & (1 << 0)) == 0);
    return NRF_Device.SPI->DR;
}

u8 NRF_Write(u8 reg, u8 *dat, u8 len)
{
    u8 status = 0;
    u8 count = 0;

    *NRF_Device.CS = 0;
    status = NRF_SPI_Data(reg);
    for (count = 0; count < len; count++)
    {
        NRF_SPI_Data(dat[count]);
    }
    *NRF_Device.CS = 1;

    return status;
}

u8 NRF_Read(u8 reg, u8 *dat, u8 len)
{
    u8 status = 0;
    u8 count = 0;

    *NRF_Device.CS = 0;
    status = NRF_SPI_Data(reg);
    for (count = 0; count < len; count++)
    {
        dat[count] = NRF_SPI_Data(0xFF);
    }
    *NRF_Device.CS = 1;

    return status;
}

void NRF_Config()
{
    u8 value = 0;
    *NRF_Device.CE = 0;

    //÷ַͨ
    NRF_Write(NRF_W_REGISTER | NRF_TX_ADDR, NRF_TX_ADDRESS, 5);
    NRF_Write(NRF_W_REGISTER | NRF_RX_ADDR_P0, NRF_RX_ADDRESS[0], 5);
    NRF_Write(NRF_W_REGISTER | NRF_RX_ADDR_P1, NRF_RX_ADDRESS[1], 5);
    NRF_Write(NRF_W_REGISTER | NRF_RX_ADDR_P2, NRF_RX_ADDRESS[2], 1);
    NRF_Write(NRF_W_REGISTER | NRF_RX_ADDR_P3, NRF_RX_ADDRESS[3], 1);
    NRF_Write(NRF_W_REGISTER | NRF_RX_ADDR_P4, NRF_RX_ADDRESS[4], 1);
    NRF_Write(NRF_W_REGISTER | NRF_RX_ADDR_P5, NRF_RX_ADDRESS[5], 1);

    //ͨݿ
    value = NRF_DATA_LENGTH;
    NRF_Write(NRF_W_REGISTER | NRF_RX_PW_P0, &value, 1);
    NRF_Write(NRF_W_REGISTER | NRF_RX_PW_P1, &value, 1);
    NRF_Write(NRF_W_REGISTER | NRF_RX_PW_P2, &value, 1);
    NRF_Write(NRF_W_REGISTER | NRF_RX_PW_P3, &value, 1);
    NRF_Write(NRF_W_REGISTER | NRF_RX_PW_P4, &value, 1);
    NRF_Write(NRF_W_REGISTER | NRF_RX_PW_P5, &value, 1);

    value = 0x3f;//ʹнͨԶӦ
    NRF_Write(NRF_W_REGISTER | NRF_EN_AA, &value, 1);
    NRF_Write(NRF_W_REGISTER | NRF_EN_RXADDR, &value, 1);

    value = 0x03;//ַ5ֽڿ
    NRF_Write(NRF_W_REGISTER | NRF_SETUP_AW, &value, 1);

    value = 0x1a;//Զط ȴ500us+86us ط10
    NRF_Write(NRF_W_REGISTER | NRF_SETUP_RETR, &value, 1);

    value = 0x28;//Ƶͨ
    NRF_Write(NRF_W_REGISTER | NRF_RF_CH, &value, 1);

    value = 0x07;//2Mbps 0dbm
    NRF_Write(NRF_W_REGISTER | NRF_RF_SETUP, &value, 1);

    value = 0x0e | NRF_Device.Mode;//ýж,ж,طж,CRCж
                                   //CRCģʽ16λ
    NRF_Write(NRF_W_REGISTER | NRF_CONFIG, &value, 1);

    *NRF_Device.CE = 1;
}
u8 NRF_Check()
{
	u8 tx_addr[5];
	u8 i = 0;

	NRF_Read(NRF_R_REGISTER | NRF_RX_ADDR_P0, tx_addr, 5);

	for (i = 0;i < 5;i++)
	{
		if (tx_addr[i] == NRF_RX_ADDRESS[0][i])
		{
			continue;
		}
		else
		{
			break;
		}
	}
	if (i < 5)
	{
		return 0;
	}
	else
	{
		return 1;
	}
}
void NRF_Switch_Mode(NRF_Mode mode)
{
    u8 value = 0;

    *NRF_Device.CE = 0;
    value = 0x0e | NRF_Device.Mode;
    NRF_Write(NRF_W_REGISTER | NRF_CONFIG, &value, 1);
    *NRF_Device.CE = 1;
}
u8 NRF_Get_Status()
{
    u8 value = 0;

    NRF_Read(NRF_R_REGISTER | NRF_STATUS, &value, 1);

    return value;
}
void NRF_Clear_IT(NRF_IT_Flag IT_Flag)
{
    u8 value = 0;

    value = 1 << IT_Flag;
    NRF_Write(NRF_W_REGISTER | NRF_STATUS, &value, 1);
}
void NRF_Tx_Data(_nrf_data_packet_* packet)
{
	*NRF_Device.CE = 0;

    NRF_Write(NRF_W_RX_PAYLOAD, (*packet).Data.Raw, NRF_DATA_LENGTH);

	*NRF_Device.CE = 1;
}
void NRF_Rx_Data(_nrf_data_packet_* packet)
{
    NRF_Read(NRF_R_RX_PAYLOAD, (*packet).Data.Raw, NRF_DATA_LENGTH);
    packet->Update_Flag = 1;
}

