#include "NRF_USER.h"

//͵ַ
u8 NRF_TX_ADDRESS[5] = { 0x10, 0x12, 0x13, 0x14, 0x15 };

//յַ
u8 NRF_RX_ADDRESS[6][5] = {
    { 0x10, 0x12, 0x13, 0x14, 0x15 },
    { 0x11, 0x12, 0x13, 0x14, 0x15 },
    { 0x12, 0x12, 0x13, 0x14, 0x15 },
    { 0x13, 0x12, 0x13, 0x14, 0x15 },
    { 0x14, 0x12, 0x13, 0x14, 0x15 },
    { 0x15, 0x12, 0x13, 0x14, 0x15 },
};

/*
ûԶNRF
*/
void USER_Config_NRF_Device()
{
    NRF_Device.CLK_Pin.GPIO_Port = GPIOB;
    NRF_Device.CLK_Pin.GPIO_Pin = 3;
    NRF_Device.CLK_Pin.GPIO_AF = GPIO_AF_SPI1;

    NRF_Device.MISO_Pin.GPIO_Port = GPIOB;
    NRF_Device.MISO_Pin.GPIO_Pin = 4;
    NRF_Device.MISO_Pin.GPIO_AF = GPIO_AF_SPI1;

    NRF_Device.MOSI_Pin.GPIO_Port = GPIOB;
    NRF_Device.MOSI_Pin.GPIO_Pin = 5;
    NRF_Device.MOSI_Pin.GPIO_AF = GPIO_AF_SPI1;

    NRF_Device.IRQ_Pin.GPIO_Port = GPIOG;
    NRF_Device.IRQ_Pin.GPIO_Pin = 8;

	NRF_Device.CE_Pin.GPIO_Port = GPIOG;
	NRF_Device.CE_Pin.GPIO_Pin = 6;

	NRF_Device.CS_Pin.GPIO_Port = GPIOG;
	NRF_Device.CS_Pin.GPIO_Pin = 7;

    NRF_Device.TIM = TIM6;

    NRF_Device.SPI = SPI1;

    NRF_Device.Mode = TX_MODE;
}

/*
ûԶRCCʼ
*/
void USER_Init_RCC()
{
    RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOB, ENABLE);
	RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOG, ENABLE);
    RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM6, ENABLE);
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_SPI1, ENABLE);
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_SYSCFG, ENABLE);
}

/*
ûԶSPIʼ
*/
void USER_Init_SPI()
{
    NRF_Device.SPI->I2SCFGR &= ~(1 << 11);
    NRF_Device.SPI->CR1 = 0;
    NRF_Device.SPI->CR1 |= (1 << 9) | (1 << 8);//NSS
    NRF_Device.SPI->CR1 |= (1 << 2);//SPIʱģʽģʽ
    NRF_Device.SPI->CR1 |= (3 << 3);//SPIٶ
    NRF_Device.SPI->CR1 |= (1 << 6);//ʹSPI
}

/*
ûԶTIMʼ
*/
void USER_Init_TIM()
{
    NRF_Device.TIM->ARR = 5000;//ؼ
    NRF_Device.TIM->PSC = 8399;//Ƶϵ+1
    NRF_Device.TIM->CNT = 0;
    NRF_Device.TIM->DIER |= (1 << 0);//ʹж
    NRF_Device.TIM->CR1 |= (1 << 7);
    NRF_Device.TIM->CR1 |= (1 << 0);
}

/*
ûԶжϳʼ
*/
void USER_Init_IRQ()
{
    NVIC_InitTypeDef NVIC_InitStruct;
    EXTI_InitTypeDef EXTI_InitStruct;

    SYSCFG_EXTILineConfig(EXTI_PortSourceGPIOG, NRF_Device.IRQ_Pin.GPIO_Pin);
    EXTI_InitStruct.EXTI_Line = 1 << NRF_Device.IRQ_Pin.GPIO_Pin;
    EXTI_InitStruct.EXTI_Mode = EXTI_Mode_Interrupt;
    EXTI_InitStruct.EXTI_Trigger = EXTI_Trigger_Falling;
    EXTI_InitStruct.EXTI_LineCmd = ENABLE;
    EXTI_Init(&EXTI_InitStruct);

    NVIC_InitStruct.NVIC_IRQChannel = EXTI9_5_IRQn;
    NVIC_InitStruct.NVIC_IRQChannelPreemptionPriority = 1;
    NVIC_InitStruct.NVIC_IRQChannelSubPriority = 3;
    NVIC_InitStruct.NVIC_IRQChannelCmd = ENABLE;
    NVIC_Init(&NVIC_InitStruct);

    NVIC_InitStruct.NVIC_IRQChannel = TIM6_DAC_IRQn;
    NVIC_InitStruct.NVIC_IRQChannelPreemptionPriority = 2;
    NVIC_InitStruct.NVIC_IRQChannelSubPriority = 2;
    NVIC_InitStruct.NVIC_IRQChannelCmd = ENABLE;
    NVIC_Init(&NVIC_InitStruct);
}

/*
ûԶ嶨ʱжϺ
*/
void USER_NRF_TIM_IRQ()
{
    if (NRF_Device.TIM->SR & (1 << 0))
    {

    }
    NRF_Device.TIM->SR &= ~(1 << 0);
}

/*
ûԶNRFжϺ
*/
void USER_NRF_IRQ()
{
    u8 value = 0;
    u8 channel = 0;

    if ((EXTI->PR & (1 << NRF_Device.IRQ_Pin.GPIO_Pin)) == (1 << NRF_Device.IRQ_Pin.GPIO_Pin))
    {
        value = NRF_Get_Status();
        if (value & (1 << RX_IT))
        {
            //ж
            channel = (value & 0x0e) >> 1;
            
            NRF_Rx_Data((_nrf_data_packet_*)(&NRF_Data.RX[channel]));

            value = 0xff;
            NRF_Write(NRF_FLUSH_RX,&value,1);
            NRF_Clear_IT(RX_IT);
            value = NRF_Get_Status();
        }
        if (value & (1 << TX_IT))
        {
            //ж
            value = 0xff;
            NRF_Write(NRF_FLUSH_TX,&value,1);
            NRF_Clear_IT(TX_IT);
            value = NRF_Get_Status();
        }
        if (value & (1 << MAX_RT_IT))
        {
            //ﵽطж
            value = 0xff;
            NRF_Write(NRF_FLUSH_TX,&value,1);
            NRF_Clear_IT(MAX_RT_IT);
        }
		EXTI->PR |= 1 << NRF_Device.IRQ_Pin.GPIO_Pin;
    }
}
